function MyShowHide(headID, bodyID)
{
    var div = document.getElementById(bodyID);
    var head = document.getElementById(headID);
    if (div.style.display == "none")
    {
        div.style.display = "inline";
    }
    else
    {
        div.style.display = "none";
    }
}
function findShowHide(ev) {
	el_node = ev.target;
	while (new String(el_node.id).indexOf('hide-head') == -1 && el_node.parentNode) {				    
	     el_node= el_node.parentNode;
	}
	if (new String(el_node.id).indexOf('hide-head') != -1) {

		MyShowHide(el_node.attributes['hide-head-id'].value,el_node.attributes['hide-body-id'].value);
	}
	
	
}

function scrollToFirstHighLight() {
	el = document.getElementsByTagName('hl')[0];
	el_pos = findPos(el);
	window.scrollTo(0,el_pos[1]);
	
	
}
function scrollToTop(){
	window.scrollTo(0,0);
}
function scrollToPosition(pos) {
	window.scrollTo(0,pos);
}

function findPos(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return [curleft,curtop];
}

//highlighting utils
function highlightSearchTerms(searchText)
{
    var searchArray = searchText.split(" ");
	var textTags=document.getElementsByTagName("z");
	for(var j = 0; j < textTags.length; j++)
	{
		var text = textTags[j].innerHTML;

		for (var i = 0; i < searchArray.length; i++)
		{

				if(text == searchArray[i])
				{
					textTags[j].innerHTML = '<highlight>' + text + '</highlight>';

				}
			}
		}
		return true;
}


function RemoveHighlight()
{
   var bodyText = document.body.innerHTML;
	bodyText = bodyText.replace(/<highlight>/g, "");
	bodyText = bodyText.replace(/<\/highlight>/g, "");
	document.body.innerHTML = bodyText;
	return true;
}

function ShowBlocks()
{
    var blocks = document.getElementsByName("hideblock");
    for(var i = 0; i < blocks.length; i++)
    {
        blocks[i].style.display = "inline";
    }
}


function HideBlocks()
{
    var blocks = document.getElementsByName("hideblock");
    for(var i = 0; i < blocks.length; i++)
    {
        blocks[i].style.display = "none";
    }
}

function onExpandAllPressed()
{
    var expand = document.getElementsByName("expand_all");
    var collapse = document.getElementsByName("collapse_all");
    for(var i = 0; i < expand.length; i++)
    {
        expand[i].style.display = "none";
    }
    for(var i = 0; i < collapse.length; i++)
    {
        collapse[i].style.display = "inline";
    }
    ShowBlocks();
}


function onCollapseAllPressed()
{
    var expand = document.getElementsByName("expand_all");
    var collapse = document.getElementsByName("collapse_all");
    for(var i = 0; i < expand.length; i++)
    {
        expand[i].style.display = "inline";
    }
    for(var i = 0; i < collapse.length; i++)
    {
        collapse[i].style.display = "none";
    }
    HideBlocks();
}

window.onclick = eventHandler;
document.ontouchstart = eventHandler;
document.ontouchend = eventHandler;
document.ontouchmove = eventHandler;


var highlight = Android.color();
var background = Android.background();

function eventHandler(ev) {
 			var parent_name = ev.target.parentNode.tagName;
			var el_name = ev.target.tagName;
			var el_node = ev.target;
			var element = null;
			var tag  = null;

			//if (!ev) var ev = window.event;
			//ev.cancelBubble = true;

			//if (ev.stopPropagation) ev.stopPropagation();
			for (i=0;i<3;i++) {
			    el_name = el_node.tagName;
			    if (el_name == 'C' || el_name =='O') {
				element = el_node;
				break;										    
			    }
                            el_node = el_node.parentNode;				
			}
			
			//if (parent_name  == 'C' || parent_name == 'O') {
			//	element = ev.target.parentNode;				
			//}

				
			if (element == null && ev.type =='click') 			
				return findShowHide(ev);
			

			el_node = ev.target;
			while (el_node.tagName.toLowerCase() != 'span' && el_node.parentNode) {				    
			    
			     el_node= el_node.parentNode;
			}
			
			if (el_node.tagName.toLowerCase() == 'span') {
						if (ev.type == 'click') 
							clickTag(element,el_node.attributes['class'].value);
						else if (ev.type == 'touchstart') 
							touchStart(element,el_node);
						else if (ev.type == 'touchend') 
							touchEnd(element,el_node);
						else if (ev.type == 'touchmove') 
							touchEnd(element,el_node.attributes['class'].value);
						return;
			}
			
			
			
			
			
			
			
}

var tmpBackground = "";
function touchStart(el,tag) {
    setRecursiveBackground(el,highlight,'hl');
    el.style["backgroundColor"] = highlight;
    el.style["padding-top"]= '12px';
    el.style["padding-bottom"]='12px';
    tmpBackground = tag.style.backgroundColor;
    lastEl = el;	
    
}
function touchEnd(el, tag) {
 	//if (tmpBackground == "transparent") { 	    
 	//    el.style["backgroundColor"] = background;
 	//} else {
 		el.style["backgroundColor"] = tmpBackground;
 	//}
    setRecursiveBackground(el,'yellow','hl');
    
}

function clickTag(el, tag) {
 	//el.style["backgroundColor"] = highlight; 
	
	Android.translate(getTextContentExceptScript(el),tag.toLowerCase());			    
} 

function setRecursiveBackground(element, color,tagName) {    
    for (var i=0,n=element.childNodes.length;i<n;i++) {
        var child = element.childNodes[i];
        if (child.nodeType===1 && child.tagName.toLowerCase() === tagName) {
            child.style["backgroundColor"] = color;
        } else {
            setRecursiveBackground(child,color,tagName);            
        } 
        
    }    
   
}
	
function disableHandler() {
   window.onclick = null;
   document.ontouchstart = null;
   document.ontouchend = null;
   document.ontouchmove = null;   
	
}
function enableHandler() {
	window.onclick = eventHandler;
	document.ontouchstart = eventHandler;
	document.ontouchend = eventHandler;
	document.ontouchmove = eventHandler;
}
function getTextContentExceptScript(element) {
    var text= [];
    for (var i= 0, n= element.childNodes.length; i<n; i++) {
        var child= element.childNodes[i];
        if (child.nodeType===1 && child.tagName.toLowerCase()!=='script')
            text.push(getTextContentExceptScript(child));
        else if (child.nodeType===3)
            text.push(child.data);
    }
    return text.join('');
}



function showRecordButton(aId)
{
    var recordButton = document.getElementById("record"+aId.toString());
    recordButton.style.display = 'inline';
    var stopRecordButton = document.getElementById("stoprecord"+aId.toString());
    stopRecordButton.style.display = 'none';
    var playButton = document.getElementById("play"+aId.toString());
    playButton.style.display = 'none';
    var stopPlayButton = document.getElementById("stopplay"+aId.toString());
    stopPlayButton.style.display = 'none';
}

function showRecordStopButton(aId)
{
    var recordButton = document.getElementById("record"+aId.toString());
    recordButton.style.display = 'none';
    var stopRecordButton = document.getElementById("stoprecord"+aId.toString());
    stopRecordButton.style.display = 'inline';
    var playButton = document.getElementById("play"+aId.toString());
    playButton.style.display = 'none';
    var stopPlayButton = document.getElementById("stopplay"+aId.toString());
    stopPlayButton.style.display = 'none';
}

function showPlayButton(aId)
{
    var recordButton = document.getElementById("record"+aId.toString());
    recordButton.style.display = 'none';
    var stopRecordButton = document.getElementById("stoprecord"+aId.toString());
    stopRecordButton.style.display = 'none';
    var playButton = document.getElementById("play"+aId.toString());
    playButton.style.display = 'inline';
    var stopPlayButton = document.getElementById("stopplay"+aId.toString());
    stopPlayButton.style.display = 'none';
}

function showPlayStopButton(aId)
{
    var recordButton = document.getElementById("record"+aId.toString());
    recordButton.style.display = 'none';
    var stopRecordButton = document.getElementById("stoprecord"+aId.toString());
    stopRecordButton.style.display = 'none';
    var playButton = document.getElementById("play"+aId.toString());
    playButton.style.display = 'none';
    var stopPlayButton = document.getElementById("stopplay"+aId.toString());
    stopPlayButton.style.display = 'inline';
}

function onRecordClick(aId)
{
    showRecordStopButton(aId);

}

function onStopRecordClick(aId)
{
    showPlayButton(aId);
}


function onPlayClick(aId)
{
    showPlayStopButton(aId);
}

function onStopPlayClick(aId)
{
    showPlayButton(aId);
}



